<meta content="text/html; charset=UTF-8" http-equiv="Content-Type">
<meta name="keywords" content="disk encryption, security, transparent, AES, plausible deniability, virtual drive, Linux, MS Windows, portable, USB drive, partition">
<meta name="description" content="LibreCrypt: An Open-Source transparent encryption program for PCs. With this software, you can create one or more &quot;containers&quot; on your PC - which appear as disks, anything written to these disks is automatically encrypted before being stored on your hard drive.">

<meta name="author" content="Sarah Dean">
<meta name="copyright" content="Copyright 2004, 2005, 2006, 2007, 2008 Sarah Dean 2015 tdk">


<TITLE>Appendix B: Credits</TITLE>

<link href="https://raw.githubusercontent.com/t-d-k/librecrypt/master/docs/styles_common.css" rel="stylesheet" type="text/css">


<link rel="shortcut icon" href="https://github.com/t-d-k/librecrypt/raw/master/src/Common/Common/images/DoxBox.ico" type="image/x-icon">

<SPAN CLASS="master_link">
[![LibreCrypt logo](https://github.com/t-d-k/librecrypt/raw/master/src/Common/Common/images/DoxBox128.png)](http://LibreCrypt.eu/)
</SPAN>
<SPAN CLASS="master_title">
_[LibreCrypt](http://LibreCrypt.eu/): Open-Source disk encryption for Windows_
</SPAN>
***

<SPAN class="tip">
The latest version of this document can be found at the [LibreCrypt project site](https://github.com/t-d-k/librecrypt)
</SPAN>      
            
## Appendix B: Credits

LibreCrypt is based on FreeOTFE developed by Sarah Dean.

Thanks go to:

* [Tom St Denis](mailto:tomstdenis@iahu.ca] for the [LibTomCrypt library](http://libtomcrypt.org/)).
* Hi/fn and Counterpane Systems for the optimised reference implementation of Twofish ([http://www.schneier.com/twofish.html](http://www.schneier.com/twofish.html)).
* Oliver Taylor for the PKCS#11 and partition display implementation, and his work on the drivers
* OSR Online ([http://www.osronline.com/](http://www.osronline.com/)) - a good resource for those writing device drivers.
* [Peter Gutmann](mailto:pgut001@cs.auckland.ac.nz)) for the cryptlib library. If installed, LibreCrypt can take advantage of this as an RNG.
* [Clemens Fruhwirth](http://clemens.endorphin.org/)), author of the LUKS specification and ESSIV.
* [David Saunders](mailto:dsaunders@gawab.com)) for setting up the www.FreeOTFE.org domain registration and web site.
* Gianluca Varenni for his USENET post **way** back in August 2002 relating to the "_alldvrm" driver problem under MS Windows 2000, and the solution he used!
* [Dr. Brian R. Gladman](mailto:gladman@seven77.demon.co.uk)) for his implementation of the 2nd round AES candidates
* [Lars B. Dybdahl](mailto:Lars@dybdahl.dk) and [Peter Thrnqvist](mailto:peter3@peter3.com) for dxgettext, an Delphi port of GNU's gettext 
* [Alexander Okorokov](mailto:oraclex@mail.ru)) for feedback and code improvements
* [Brian Smith](mailto:bsmith@ringcube.com) for identifying, tracking down and debugging an intermittent driver issue which could cause crashing when dismounting

* * * 
<A NAME="level_3_heading_1">
### Translations


<TABLE> 
<TR> <TH>Language</TH> <TH>Translator</TH> </TR>
<TR>   <TD>Croatian</TD>   <TD> [Zlatko Zivkovic] (mailto:zzivkovic@cogeco.ca) <BR> dboki89 (mailto:dboki89@yahoo.com) </TD> </TR> 
<TR>   <TD>Czech</TD>   <TD>[Tomas Ruzicka](mailto:tr3027@seznam.cz)</TD> </TR>
<TR>   <TD>French</TD>   <TD>[Daniel Berthereau](mailto:Daniel.fr@Berthereau.net)</TD> </TR> 
<TR>   <TD>German</TD>   <TD>[Volkmar Brandmaier](mailto:brandmaier@gmx.net)</TD> </TR> 
<TR>   <TD>Greek</TD>   <TD>[Geogeo](mailto:geogeo64@yahoo.gr)</TD> </TR>
<TR>   <TD>Italian</TD>   <TD>[Daniele](mailto:fuzzee@virgilio.it)</TD> </TR>
<TR>   <TD>Japanese</TD>   <TD>[Hiroaki Ohtsuka](mailto:hgc00566@nifty.ne.jp)</TD> </TR> 
<TR>   <TD>Russian</TD>   <TD>[Dmitry Yerokhin](mailto:erodim@mail.ru)</TD> </TR> 
<TR>   <TD>Simplified Chinese</TD>   <TD>Erik</TD> </TR>
<TR>   <TD>Spanish</TD>   <TD>[Luis Santalla](mailto:luis.santalla@hotmail.com)</TD> </TR>
</TABLE>

